#!/bin/sh
#Format floppy disks
#Copyright (c) Barry Kauler 2004 www.goosee.com/puppy
#2007 Lesser GPL licence v2 (http://www.fsf.org/licensing/licenses/lgpl.html)

zapfloppy()
{
# Puppy will only allow 1440, 1680K and 1760K capacities.
ERR0=1
while [ ! $ERR0 -eq 0 ];do
xmessage -bg "#c0ffff" -center -title "Por favor espere Ud..." -buttons "" "Formateando disquete a Bajo-Nivel con $1 Kbytes de capacidad" &
 fdformat /dev/fd0u$1
 ERR0=$?
 killall xmessage
 if [ ! $ERR0 -eq 0 ];then
  xmessage -bg "#ffe0e0" -name "loformat" -title "Puppy Formateador de Bajo-Nivel" -center \
  -buttons "Volver a intentar":20,"SALIR":10 -file -<<XMSG
ERROR formateando a bajo-nivel.
Est activada la proteccin contra escritura?
XMSG

  AN0=$?
  if [ $AN0 -eq 10 ];then
   ERR0=0
  fi
  if [ $AN0 -eq 0 ];then
   ERR0=0
  fi
  if [ $AN0 -eq 1 ];then
   ERR0=0
  fi
 else
  INTROMSG="`
echo "SATISFACTORIO"
echo -e "Ahora presione el botn \"Msdos/vfat filesystem\""
`"
 fi
done
}

fsfloppy()
{
echo "Creando sistema de archivos tipo Ms-dos en el disquete..."
ERR1=1
while [ ! $ERR1 -eq 0 ];do
xmessage -bg "#c0ffff" -center -title "Por favor espere Ud...." -buttons "" "Creando sistema de archivos msdos/vfat en el disquete" &
 mkfs.msdos -c /dev/fd0u$1
 #mformat -f $1 a:
 #mbadblocks a:
 ERR1=$?
 killall xmessage
 if [ ! $ERR1 -eq 0 ];then
  xmessage -bg "#ffe0e0" -name "msdosvfat" -title "Disco con sistema de archivos msdos/vfat" -center \
  -buttons "Volver a intentar":20,"SALIR":10 -file -<<XMSG
ERROR creando sistema de archivos msdos/vfat en el disquete.
Est activada la proteccin contra escritura?
XMSG

  AN0=$?
  if [ $AN0 -eq 10 ];then
   ERR1=0
  fi
  if [ $AN0 -eq 0 ];then
   ERR1=0
  fi
  if [ $AN0 -eq 1 ];then
   ERR1=0
  fi
 else
  INTROMSG="`
echo "SATISFACTORIO"
echo "El disquete ya est listo para ser utilizado."
echo " Usar Puppy Mounter para montarlo."
echo " (NOTA: si utiliza el gestor de disquetera MToolsFM"
echo " entonces la disquetera se accede directamente,"
echo " as que no use Puppy Mounter)"
echo "En primer lugar, pulse SALIR..."
`"
 fi
done
sync
echo "...Listo."
echo " "
}

INTROMSG="`
echo "Bienvenido!"
echo "EL Formateador Puppy de disquetes hace formatos de disquetes slo"
echo "de 1440 KByte de capacidad y con el sitema de ficheros msdos/vfat"
echo "para intercambio con sistemas Windows."
echo ""
echo "Ud. necesita  formatear a bajo-nivel si el disquete est formateado"
echo "con algn otra capacidad, o que est daado. No"
echo "es necesario en disquete nuevo, pero pueden hacerlo para"
echo "verificar su correcta integridad."
echo "Un disco NO es utilizable si es slo a se ha formateado a bajo-nivel: debe"
echo "tambin contener un sistema de ficheros, por lo que este debe ser siempre"
echo "el segundo paso".
echo "Hacer slo el 2do. paso, es decir, la creacin de un sistema de ficheros en un"
echo "disquete, es tambin un mtodo para borrar cualquier archivo existente."
`"

#big loop...
while :; do

MNTDMSG=" "
mount | grep "/dev/fd0" > /dev/null 2>&1
if [ $? -eq 0 ];then #=0 if string found
 CURRENTMNT="`mount | grep "/dev/fd0" | cut -f 3 -d ' '`"
 #this tells Rox to close any window with this directory and subdirectories open...
 rox -D "$CURRENTMNT"
 sync
 umount "$CURRENTMNT" #/mnt/floppy
 if [ ! $? -eq 0 ];then
  MNTDMSG="`
echo " "
echo "Puppy encuentra un disquete montado en la unidad, pero"
echo "no es capaz de desmontarlo. El disquete debe estar sin montar ahora".
echo "Por favor, utilice Ud. Puppy Mounter (en el men Archivos)"
echo "para desmontar el disquete. HAGA ESTO PRIMERO!"
echo ""
`"
 else
  MNTDMSG="`
echo " "
echo "Puppy encontr que el disquete estaba montado, pero ahora"
echo "quedo sin montar. Perfecto para el formateado"
echo " "
`"
 fi
fi

xmessage -bg "#e0ffe0" -name "pformat" -title "Puppy Formateador de disquete" -center \
-buttons "Formatear a Bajo-nivel":20,"Tipo Msdos/vfat":30,"SALIR":10 -file -<<XMSG
$INTROMSG
$MNTDMSG
Presione un botn:
XMSG

ANS=$?

if [ $ANS -eq 0 ]; then
 break
fi
if [ $ANS -eq 1 ]; then
 break
fi
if [ $ANS -eq 10 ]; then
 break
fi

if [ $ANS -eq 20 ];then #format
 zapfloppy 1440
fi

if [ $ANS -eq 30 ];then #vfat
 fsfloppy 1440
fi

done
